Module Module1

  Public Sub CreateSnippet(ByVal fileName As String, ByVal description As String)
    Dim Snippet As XDocument = _
      <?xml version="1.0" encoding="utf-8"?>
      <html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
        <head>
        </head>
        <body>
          <p><%= description %></p>
        </body>
      </html>
    Snippet.Save("C:\Example\Content\Resources\Snippets\" & fileName)
  End Sub

  Public Sub CreateTopic(ByVal fileName As String, ByVal topicName As String)
    Dim Topic As XDocument = _
      <?xml version="1.0" encoding="utf-8"?>
      <html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
        <head><title><%= topicName %></title>
        </head>
        <body>
          <h1><%= topicName %></h1>
          <MadCap:snippetBlock src=<%= "Resources/Snippets/" _
                         & topicName & "-Refreshable.flsnp" %>/>
          <MadCap:snippetBlock src=<%= "Resources/Snippets/"_
					 & topicName & "-EditInFlare.flsnp" %>/>
        </body>
      </html>
    Topic.Save("C:\Example\Content\" & fileName)
  End Sub

  Sub Main()
    Dim FlareToc As XDocument = _
      <?xml version="1.0" encoding="utf-8"?>
      <CatapultToc></CatapultToc>

    Using MyReader As New FileIO.TextFieldParser("C:\Example\wonderful-things.csv")
      MyReader.TextFieldType = FileIO.FieldType.Delimited
      MyReader.SetDelimiters(",")
      Dim currentRow As String()
      While Not MyReader.EndOfData
        currentRow = MyReader.ReadFields()
        CreateTopic(currentRow.First & ".htm", currentRow.First)
        CreateSnippet(currentRow.First & "-Refreshable.flsnp", currentRow.Last)
        CreateSnippet(currentRow.First & "-EditInFlare.flsnp", "Default text")
        FlareToc.Add()
        FlareToc.Root.Add(<TocEntry Link=<%= "/Content/" _
                           & currentRow.First _
                           & ".htm" %> Title=<%= currentRow.First %>>
                  </TocEntry>)
      End While
    End Using
    FlareToc.Save("C:\Example\Project\TOCs\wonderful-things.fltoc")
  End Sub
End Module